{% extends "ajax/game/game.html.twig" %}
{% block title %}{{ forum.title|raw }} - {{ 'Seite {page}'|trans({'{page}': current_page}, 'global')|raw }}{% endblock %}
{% block menu_text %}
    {{parent()}}
    <li class="back-dash" x-ajax-href="{{ url('game_landing') }}">{{ 'Zum Spiel'|trans({},'global') }}</li>
{% endblock %}

{# @var forum \App\Entity\Forum #}
{# @var permission \App\Structures\ForumPermissionAccessor #}

{% macro display_thread_list( list, fid, icon, title, select, jump, permission, town = false, add_seperators = false, paranoid = false, post_page = -1 ) %}
    <div class="forum-note thread-list-{{ icon }}">
        <b><i class="fa {{ icon }}"></i> {{ title }}</b>
        {% set last_day = 'today'|to_date %}
        {% for thread in list %}
            {% set postUrl = path('forum_viewer_controller', {fid: fid, tid: thread.id }) %}
            {% if thread.id == select and jump > 0 %}
                {% set postUrlFg = path('forum_viewer_controller', {fid: fid, tid: thread.id, pid: jump }) %}
            {% else %}
                {% set postUrlFg = postUrl %}
            {% endif %}

            {% if thread.id == select and post_page > 0 %}
                {% set page_target = post_page %}
            {% else %}
                {% set page_target = -1 %}
            {% endif %}

            {% if add_seperators and thread.lastPost(thread.hidden??false) and last_day != thread.lastPost(thread.hidden??false).date|date_modify('today') %}
                {% set last_day = thread.lastPost(thread.hidden??false).date|date_modify('today') %}
                <div class="row forum-separator"><div class="cell rw-12 padded-small">
                    {% if last_day >= 'today'|to_date %}{{ 'Heute'|trans({},'global') }}
                    {% elseif last_day >= 'yesterday'|to_date %}{{ 'Gestern'|trans({},'global') }}
                    {% elseif last_day >= 'tomorrow-1week'|to_date %}{{last_day|format_datetime(pattern="EEEE")}}
                    {% else %}{{last_day|format_datetime('full', 'none')}}{% endif %}
                </div></div>
            {% endif %}

            <div class="row-flex stretch forum-thread {% if thread.new %}forum-thread-unread{% endif%}" x-public-route="{{ path('forum_thread_view', {fid: fid, tid: thread.id }) }}" {% if postUrl != postUrlFg %}x-post-source-next="{{ postUrlFg }}"{% endif%} {% if page_target > 0 %}x-post-page="{{ page_target }}" x-public-route-next="{{ path('forum_thread_view', {fid: fid, tid: thread.id, page: page_target }) }}"{% endif%} x-post-source="{{ postUrl }}" x-thread-id="{{ thread.id }}">
                {# @var thread \App\Entity\Thread #}
                <div class="padded cell factor-0 rw-1 status">
                    {% if thread.locked and not thread.solved %}
                        <img style="position: absolute" alt="" src="{{ asset('build/images/icons/lock.gif') }}" />
                    {% elseif thread.locked and thread.solved %}
                        &nbsp;<img style="position: absolute" alt="" src="{{ asset('build/images/icons/done.png') }}" />
                    {% endif %}
                </div>
                <div class="padded cell factor-0 rw-8 title">
                    <div {% if thread.hidden %}style="color: red"{% endif %}>
                        {% if thread.translatable %}
                            {{ thread.title|trans({},'game') }}
                        {% else %}
                            {% if paranoid and thread.owner and thread.owner != app.user %}
                                {% set mode = (app.user.id + thread.id + thread.owner.id) % 12 %}
                                {% if mode == 0 %}
                                    {{ 'Hängt {user}!'|trans({'{user}': app.user.activeCitizen.alias ?? app.user.name},'game') }}
                                {% elseif mode == 1 %}
                                    {{ '{user} wir kriegen dich!'|trans({'{user}': app.user.activeCitizen.alias ?? app.user.name},'game') }}
                                {% else %}
                                    {{ thread.title }}
                                {% endif %}
                            {% else %}
                                {{ thread.title }}
                            {% endif %}
                        {% endif %}
                        {% if permission.moderate and thread.reportedPosts %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/warning.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Mindestens ein Post in diesem Thema wurde den Moderatoren gemeldet.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                        {% if thread.hasAdminAnnounce %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/adminAnnounce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält offizielle Ansagen der Website Administratoren.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% elseif thread.hasOracleAnnounce %}
                            <span class="float-right">
                                <img src="{{ asset('build/images/forum/announce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält Ansagen von Community-Vertretern.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                        {% if thread.tag %}
                            <span class="float-right thread-tag" style="background-color: {{ thread.tag.color|color }}; color: {{ thread.tag.color|color|textcolor }}">
                                {{ thread.tag.label|trans({},'global') }}
                            </span>
                        {% endif %}
                    </div>
                </div>
                <div class="padded cell factor-0 rw-3 right count">
                    <div class='nbPost'>
                    {% if thread.visiblePosts|length > 1 %}
                        {{ thread.visiblePosts|length - 1 }}
                    {% else %}
                        &nbsp;
                    {% endif %}
                    </div>
                    <div class="author">
                        {% if thread.lastPost and thread.lastPost.owner %}
                            {% include 'ajax/soul/playername.html.twig' with {user: thread.lastPost.owner, plain: true, globalSpace: thread.forum.town is null} only %}
                        {% elseif thread.owner %}
                            {% include 'ajax/soul/playername.html.twig' with {user: thread.owner, plain: true, globalSpace: thread.forum.town is null} only %}
                        {% else %}
                            {{ 'Der Rabe'|trans({},'global') }}
                        {% endif %}
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
{% endmacro %}

{% block ajax %}
    <div class="row">
        <div class="cell rw-12">
            <div class="row">
                <div class="cell padded rw-5 rw-md-12">
                    <div class="forum-control">
                        <div class="forum-header-bar">
                            <a href="#" x-ajax-href="{{ url('forum_list') }}">{{ 'Alle Foren'|trans({},'global') }}</a>
                            <span><i class="fa fa-caret-right"></i></span>
                            {% if forum.worldForumLanguage %}
                                <img style="height: 15px; width: auto;" alt="forum.worldForumLanguage" src="{{ asset('build/images/lang/' ~ forum.worldForumLanguage ~ '.png') }}" >
                                <span><i class="fa fa-caret-right"></i></span>
                            {% endif %}
                            <b><i class="fa fa-scroll"></i> {{ forum.title }}</b>
                        </div>
                        <div class="forum-button-bar">
                            <div x-ajax-href="{{ url('forum_list') }}" class="forum-button"><img alt="" src="{{ asset('build/images/forum/back.png') }}" /><div class="tooltip forum-tooltip">{{ 'Zurück'|trans({},'global') }}</div></div>
                            {% if select > 0 %}
                                <div x-ajax-href="{{ url('forum_thread_view', {fid: forum.id, tid: select, page: post_page}) }}" class="forum-button forum-reload-button"><img alt="" src="{{ asset('build/images/forum/refresh.png') }}" /><div class="tooltip forum-tooltip">{{ 'Liste der Themen aktualisieren'|trans({},'global') }}</div></div>
                            {% else %}
                                <div x-ajax-href="{{ url('forum_view', {id: forum.id}) }}" class="forum-button forum-reload-button"><img alt="" src="{{ asset('build/images/forum/refresh.png') }}" /><div class="tooltip forum-tooltip">{{ 'Liste der Themen aktualisieren'|trans({},'global') }}</div></div>
                            {% endif %}

                            {% if not permission.only_mod_access %}
                                <div x-forum-action="search" class="forum-button"><img alt="" src="{{ asset('build/images/forum/search.png') }}" /><div class="tooltip forum-tooltip">{{ 'Nachrichten suchen'|trans({},'global') }}</div></div>
                            {% endif %}
                            {% if app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionForum')) or not permission.create_thread() %}
                                <div class="forum-button-disabled" id="banned">{{ 'Neues Thema'|trans({},'global') }}</div>
                            {% else %}
                                <div x-forum-action="new" class="forum-button" id="new-thread-button"><span>{{ 'Neues Thema'|trans({},'global') }}</span></div>
                            {% endif %}    
                        </div>
                    </div>
                    <br />
                    {% if forum.description is not empty %}
                        <div class="forum-control">
                            <div class="quote">
                                <i class="fa fa-quote-left"></i><span>{{ forum.description }}</span><i class="fa fa-quote-right"></i>
                            </div>
                        </div>
                        <br />
                    {% endif %}

                    {% if permission.only_mod_access %}
                        <div class="forum-control">
                            <b><i class="fa fa-exclamation"></i> {{ 'Moderation'|trans({},'global') }}</b>
                            <div class="pad">{{ 'Du moderierst dieses Forum, verfügst aber nicht über Leserechte. Es werden dir nur Threads angezeigt, in denen mindestens ein Post gemeldet wurde.'|trans({}, 'global') }}</div>
                        </div>
                        <br />
                    {% endif %}

                    {% if pinned_threads %}
                        {{ _self.display_thread_list(pinned_threads, forum.id, 'fa-thumbtack', 'Sticky'|trans({}, 'global'), select, jump, permission, town, false, false, post_page) }}
                        <br />
                    {% endif %}

                    {{ _self.display_thread_list(threads, forum.id, 'fa-scroll', forum.title, select, jump, permission, town, true, paranoid, post_page) }}
                    {% if pages > 1 %}
                        <div class="row">
                            <div class="cell rw-12 padded center">
                                {% if current_page > 1 %}
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="1"><img alt="" src="{{ asset('build/images/icons/small_prev.gif') }}" /></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page - 1 }}"><img alt="" src="{{ asset('build/images/icons/small_moveleft.gif') }}" /></div>
                                {% else %}
                                <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_prev.gif') }}" /></div>
                                <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_moveleft.gif') }}" /></div>
                                {% endif %}
                                <div class="forum-button" x-forum-action="thread-select-page" data-thread-current-page="{{ current_page }}">
                                    {{ 'Seite {page}/{pages}'|trans({'{page}': '<span class="current_page_marker">&nbsp;' ~ current_page ~ '</span>', '{pages}': pages},'global')|raw }}
                                    <div class="tooltip">
                                        {{ 'Zum Wechsein der Seite hier klicken'|trans({}, 'global') }}
                                    </div>
                                </div>
                                {% if current_page < pages %}
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page + 1 }}"><img alt="" src="{{ asset('build/images/icons/small_move.gif') }}" /></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ pages }}"><img alt="" src="{{ asset('build/images/icons/small_next.gif') }}" /></div>
                                {% else %}
                                <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_move.gif') }}" /></div>
                                <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_next.gif') }}" /></div>
                                {% endif %}
                            </div>
                        </div>
                    {% endif %}
                </div>

                <div class="cell padded rw-7 rw-md-12">
                    <div id="forum-content">
                        <div class="forum-note">
                            <b>{{ 'Bitte halte dich an die Regeln:'|trans({},'global') }}</b>
                            <ul>
                                <li>{{ 'Achte auf deine Rechtschreibung'|trans({},'global') }}</li>
                                <li>{{ 'Bleibe höflich und freundlich'|trans({},'global') }}</li>
                                <li>{{ 'Werbung ist verboten (Links etc.)'|trans({},'global') }}</li>
                            </ul>
                        </div>
                    </div>
                    <div id="forum-forum-editor"></div>
                    <div id="forum-editor-anchor"></div>

                </div>
            </div>

        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>

        function get_forum_editor() {
            let editor = document.getElementById('forum-forum-editor');
            if (!editor) {
                editor = document.createElement('div');
                editor.setAttribute('id', 'forum-forum-editor');
                let anchor = document.getElementById('forum-editor-anchor');
                anchor.parentNode.insertBefore(editor, anchor);
            }
            return editor;
        }

        {% if not app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionForum')) and permission.create_thread() %}
            $.html.addEventListenerAll('[x-forum-action=new]', 'click', function() {
                $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
                let viewer = document.getElementById('forum-content');
                {let c; while ((c = viewer.firstChild)) viewer.removeChild(c);}
                $.ajax.no_history().load( get_forum_editor(), '{{ url('forum_thread_editor_controller', {id: forum.id}) }}', false )
            });
        {% endif %}

        {% if not permission.only_mod_access %}
            $.html.addEventListenerAll('[x-forum-action=search]', 'click', function() {
                $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
                let viewer = document.getElementById('forum-content');
                {let c; while ((c = viewer.firstChild)) viewer.removeChild(c);}
                $.ajax.no_history().load( viewer, '{{ url('forum_id_search_controller', {fid: forum.id}) }}', false, null, () => {
                    document.getElementById('search-query').focus();
                } )
            });
        {% endif %}

        $.html.addEventListenerAll('[x-thread-id]', 'click', function (e,elem) {
            $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
            elem.classList.add('selected');
            let editor = get_forum_editor();
            { let c; while ((c = editor.firstChild)) editor.removeChild(c); }

            let load_url = elem.getAttribute('x-post-source');
            if (elem.getAttribute('x-post-source-next')) {
                load_url = elem.getAttribute('x-post-source-next');
                elem.removeAttribute('x-post-source-next');
            }

            let opts = {};
            if (elem.hasAttribute('x-post-page')) {
                opts.page = parseInt( elem.getAttribute('x-post-page') );
                elem.removeAttribute('x-post-page');
            }


            $.ajax.no_history().load(document.getElementById('forum-content'), load_url, false, opts, get_forum_editor)
            if (elem.hasAttribute('x-public-route-next')) {
                $.ajax.push_history(elem.getAttribute('x-public-route-next'));
                elem.removeAttribute('x-public-route-next');
            } else {
                $.ajax.push_history(elem.getAttribute('x-public-route'));
                $.html.forEach('.forum-reload-button', e => e.setAttribute('x-ajax-href', elem.getAttribute('x-public-route')));
            }

        });

        $.html.addEventListenerAll('[x-thread-id]', 'mousedown', function (e,elem) {
            if (e.button === 1) {
                e.preventDefault();
                window.open(elem.getAttribute('x-public-route'), '_blank');
            }
        });

        let selection_target = document.querySelector('[x-thread-id="{{ select }}"]');
        if (selection_target) selection_target.click();

        $.html.addEventListenerAll( '[x-forum-action="thread-pager"][x-to-page]', 'click',
            (e,elem) => $.ajax.no_history().load( null, '{{ path('forum_view', {id: forum.id}) }}', false, {page: parseInt( elem.getAttribute('x-to-page') )} ) );

        $.html.addEventListenerAll( '[x-forum-action="thread-select-page"]', 'click', function(e,elem) {
            e.preventDefault();
            e.stopPropagation();
            let pagMarker = elem.querySelector(".current_page_marker");
            pagMarker.innerHTML = '<input type="text" name="page_to_go" class="page_to_go inline" style="width: 24px;margin: 0 5px" />';
            elem.querySelector("input.page_to_go").focus();
            $.html.addEventListenerAll('[x-forum-action="thread-select-page"] input.page_to_go', 'click', function(e, elem){
                e.preventDefault();
                e.stopPropagation();
            });
            $.html.addEventListenerAll('[x-forum-action="thread-select-page"] input.page_to_go', 'change', function(e, elem){
                let editor = get_forum_editor();
                {% if editor is defined %}
                {let c; while ((c = editor.firstChild)) editor.removeChild(c);}
                {% endif %}
                let to_page = parseInt( elem.value );
                if (isNaN(to_page))
                    return;
                if (to_page > {{ pages }})
                    to_page = {{ pages }};
                if (to_page < 1) to_page = 1;
                $.ajax.push_history('{{ path('forum_view', {id: forum.id}) }}/' + to_page);
                $.ajax.no_history().load( null, '{{ path('forum_view', {id: forum.id}) }}', false, {page: to_page});
            });
        } );
    </script>
{% endblock %}